﻿namespace TabsStudioRestoreToolbar
{
    public class RestoreToolbar : TabsStudioExt.ITabsStudioAddin
    {
        public RestoreToolbar()
        {
            menuItem = new System.Windows.Controls.MenuItem();
            menuItem.Header = "Restore Tabs Studio toolbar";
            menuItem.Click += Restore;
        }

        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte_)
        {
            engine = engine_;
            dte = dte_;
            engine.OpeningTabExtensionContextMenu += OpeningTabExtensionContextMenu;
            engine.OpeningTabContextMenu += OpeningTabContextMenu;
        }

        public void OnDisconnection()
        {
            engine.OpeningTabExtensionContextMenu -= OpeningTabExtensionContextMenu;
            engine.OpeningTabContextMenu -= OpeningTabContextMenu;
        }

        private void OpeningTabExtensionContextMenu(object sender, TabsStudioExt.OpeningTabExtensionContextMenuEventArgs e)
        {
            PlaceMenuItem(menuItem, e.ContextMenu);
        }

        private void OpeningTabContextMenu(object sender, TabsStudioExt.OpeningTabContextMenuEventArgs e)
        {
            PlaceMenuItem(menuItem, e.ContextMenu);
        }

        private void Restore(object sender, System.Windows.RoutedEventArgs e)
        {
            dte.ExecuteCommand("TabsStudio.Connect.RestoreToolbar", "");
            System.Windows.MessageBox.Show("The Tabs Studio toolbar has been restored.", "Restore Toolbar");
        }

        private void PlaceMenuItem(System.Windows.Controls.MenuItem menuItem,
            System.Windows.Controls.ContextMenu menu)
        {
            foreach (object item in menu.Items)
            {
                if (item is System.Windows.Controls.Control)
                {
                    if ((item as System.Windows.Controls.Control).Name.Equals("TabsStudio"))
                    {
                        menu.Items.Insert(menu.Items.IndexOf(item), menuItem);
                        break;
                    }
                }
            }
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private EnvDTE80.DTE2 dte;
        private System.Windows.Controls.MenuItem menuItem;
    }
}
